//*****************************************************************************
//
// @brief   Font renderer for fonts generated by lcd-image-converter utility
//          (see https://github.com/riuson/lcd-image-converter)
// @author  Vadim Mezhlumov
//
//*****************************************************************************
#pragma once

#include "ui/font.h"


// ----------------------------------------------------------------------------
// Types
// ----------------------------------------------------------------------------

    // Character data info
    typedef struct
    {
        const uint8*    data;
        uint16          width;
        uint16          height;
        uint8           dataSize;   // Only 8-bits data is supported
    } TLicCharInfo;

    // Character descriptor
    typedef struct
    {
        long int code;
        const TLicCharInfo* image;
    } TLicCharDesc;

    // Font descriptor
    typedef struct
    {
        int length;
        const TLicCharDesc* chars;
    } TLicFontDesc;

    // In order to use data types from above in each font file generated by LCD Image Converter
    // the following lines should be inserted:
    // #include "ui/fonts/lcd_image_converter.h"
    // typedef TLicCharInfo tImage;
    // typedef TLicCharDesc tChar;
    // typedef TLicFontDesc tFont;
    // extern const TLicFontDesc fontName;


// ----------------------------------------------------------------------------
// CFontLcdImgConv
// ----------------------------------------------------------------------------

class CFontLcdImgConv: public IFont
{
    public:
        /**
         * @brief  Constructor
         * @param  pDesc: Pointer to font descriptor
         */
        CFontLcdImgConv (const TLicFontDesc* pDesc);

        /**
         * @brief  Destructor
         * @param  None
         */
        ~CFontLcdImgConv ();

        /**
         * @brief  Get font height
         * @return Font height (pixels)
         */
        uint GetHeight (void);

        /**
         * @brief  Get symbol width
         * @param  c: Symbol code
         * @return Symbol width (pixels)
         */
        uint GetWidth (int c);

        /**
         * @brief  Render symbol
         * @param  renderer: Renderer
         * @param  c: Symbol code
         * @param  color: Text color
         * @return 0 or negative error code
         */
        int Render (CRenderer& renderer, int c, TColor color);

    private:
        const TLicFontDesc* m_pDesc;
};
